<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>IPAuthenticationProvider.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.auth</a> &gt; <span class="el_source">IPAuthenticationProvider.java</span></div><h1>IPAuthenticationProvider.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.auth;

import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.server.ServerCnxn;

<span class="fc" id="L25">public class IPAuthenticationProvider implements AuthenticationProvider {</span>

    public String getScheme() {
<span class="fc" id="L28">        return &quot;ip&quot;;</span>
    }

    public KeeperException.Code
        handleAuthentication(ServerCnxn cnxn, byte[] authData)
    {
<span class="nc" id="L34">        String id = cnxn.getRemoteSocketAddress().getAddress().getHostAddress();</span>
<span class="nc" id="L35">        cnxn.addAuthInfo(new Id(getScheme(), id));</span>
<span class="nc" id="L36">        return KeeperException.Code.OK;</span>
    }

    // This is a bit weird but we need to return the address and the number of
    // bytes (to distinguish between IPv4 and IPv6
    private byte[] addr2Bytes(String addr) {
<span class="fc" id="L42">        byte b[] = v4addr2Bytes(addr);</span>
        // TODO Write the v6addr2Bytes
<span class="fc" id="L44">        return b;</span>
    }

    private byte[] v4addr2Bytes(String addr) {
<span class="fc" id="L48">        String parts[] = addr.split(&quot;\\.&quot;, -1);</span>
<span class="fc bfc" id="L49" title="All 2 branches covered.">        if (parts.length != 4) {</span>
<span class="fc" id="L50">            return null;</span>
        }
<span class="fc" id="L52">        byte b[] = new byte[4];</span>
<span class="fc bfc" id="L53" title="All 2 branches covered.">        for (int i = 0; i &lt; 4; i++) {</span>
            try {
<span class="fc" id="L55">                int v = Integer.parseInt(parts[i]);</span>
<span class="pc bpc" id="L56" title="2 of 4 branches missed.">                if (v &gt;= 0 &amp;&amp; v &lt;= 255) {</span>
<span class="fc" id="L57">                    b[i] = (byte) v;</span>
                } else {
<span class="nc" id="L59">                    return null;</span>
                }
<span class="nc" id="L61">            } catch (NumberFormatException e) {</span>
<span class="nc" id="L62">                return null;</span>
<span class="fc" id="L63">            }</span>
        }
<span class="fc" id="L65">        return b;</span>
    }

    private void mask(byte b[], int bits) {
<span class="nc" id="L69">        int start = bits / 8;</span>
<span class="nc" id="L70">        int startMask = (1 &lt;&lt; (8 - (bits % 8))) - 1;</span>
<span class="nc" id="L71">        startMask = ~startMask;</span>
<span class="nc bnc" id="L72" title="All 2 branches missed.">        while (start &lt; b.length) {</span>
<span class="nc" id="L73">            b[start] &amp;= startMask;</span>
<span class="nc" id="L74">            startMask = 0;</span>
<span class="nc" id="L75">            start++;</span>
        }
<span class="nc" id="L77">    }</span>

    public boolean matches(String id, String aclExpr) {
<span class="nc" id="L80">        String parts[] = aclExpr.split(&quot;/&quot;, 2);</span>
<span class="nc" id="L81">        byte aclAddr[] = addr2Bytes(parts[0]);</span>
<span class="nc bnc" id="L82" title="All 2 branches missed.">        if (aclAddr == null) {</span>
<span class="nc" id="L83">            return false;</span>
        }
<span class="nc" id="L85">        int bits = aclAddr.length * 8;</span>
<span class="nc bnc" id="L86" title="All 2 branches missed.">        if (parts.length == 2) {</span>
            try {
<span class="nc" id="L88">                bits = Integer.parseInt(parts[1]);</span>
<span class="nc bnc" id="L89" title="All 4 branches missed.">                if (bits &lt; 0 || bits &gt; aclAddr.length * 8) {</span>
<span class="nc" id="L90">                    return false;</span>
                }
<span class="nc" id="L92">            } catch (NumberFormatException e) {</span>
<span class="nc" id="L93">                return false;</span>
<span class="nc" id="L94">            }</span>
        }
<span class="nc" id="L96">        mask(aclAddr, bits);</span>
<span class="nc" id="L97">        byte remoteAddr[] = addr2Bytes(id);</span>
<span class="nc bnc" id="L98" title="All 2 branches missed.">        if (remoteAddr == null) {</span>
<span class="nc" id="L99">            return false;</span>
        }
<span class="nc" id="L101">        mask(remoteAddr, bits);</span>
<span class="nc bnc" id="L102" title="All 2 branches missed.">        for (int i = 0; i &lt; remoteAddr.length; i++) {</span>
<span class="nc bnc" id="L103" title="All 2 branches missed.">            if (remoteAddr[i] != aclAddr[i]) {</span>
<span class="nc" id="L104">                return false;</span>
            }
        }
<span class="nc" id="L107">        return true;</span>
    }

    public boolean isAuthenticated() {
<span class="fc" id="L111">        return false;</span>
    }

    public boolean isValid(String id) {
<span class="fc bfc" id="L115" title="All 2 branches covered.">        return addr2Bytes(id) != null;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>